<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Document</title>
    <style>
       mi-mensaje {
           display: block;
           padding: 10px;
           border: 10px solid red;
           margin-bottom: 10px;
       }

       mi-mensaje [casi-visible] {
           border: none;
       }
    </style>
</head>
<body>

        <mi-mensaje msj="hola, soy un mensaje">aqui</mi-mensaje>
        <mi-mensaje casi-visible msj="hola, soy un mensaje casi visible">aqui</mi-mensaje>
    <script>
        class MiMensaje extends HTMLElement {

            constructor () {
                super();
                this.addEventListener('click', function(e) {
                    alert ('click en mensaje');
                });
                console.log('constructor: cuando el elemento es creado');
            }

            static get observedAttributes() {
                return ['msj','casi-visible']
            }

            connectedCallback (){
                console.log('conectedCallback: Cuando el elemento es insertado en el documento');
            }

            disconnectedCallback(){
                alert('disconnected: cuando el elemento es eliminado')
            }

/*             adoptedCallback(){
                alert('adoptedCallback: cuando el elemento es adoptado por otro documento');
            }*/

            attributeChangedCallback (attrName, oldVal, newVal) {
                console.log('attributeChangedCallback: cuando cambia un atributo');
                if(attrName === 'msj'){
                    this.pintarMensaje(newVal);
                }
                if(attrName === 'casi-visible'){
                    this.setCasiVisible();
                }
            }

            pintarMensaje(msj){
                this.innerHTML = msj
            }

            get msj(){
                return this.getAttribute('msj');
            }

            set msj(val){
                this.setAttribute('msj',val);
            }

            get casiVisible(){
             return this.hasAttribute('casi-visible');
            }

            set casiVisible(value) {
                if(value) {
                    this.setAttribute('casi-visible','');
                }else{
                    this.removeAttribute('casi-visible')
                }
            }

            setCasiVisible() {
                if(this.casiVisible){
                    this.style.opacity = 0.1;
                }else {
                    this.style.opacity = 1;
                }
            }
    }

    customElements.define('mi-mensaje',MiMensaje);


    let miMensaje = document.createElement('mi-mensaje')
    miMensaje.msj = 'otro mensaje';
    document.body.appendChild(miMensaje);

    let tercerMensaje = new MiMensaje();
    tercerMensaje.msj = 'tercer mensaje';
    document.body.appendChild(tercerMensaje);
        </script>
</body>
</html>